========================
impressive documentation
========================

Folders:  

    exec/  
        This folder contains symbolic links to impressive.py, the impressive_json-generator.py and run.py.  
        exec/ is your working directory, where you should place your content and generated JSONs.  
  
    src/  
        This source folder contains an example and all sources of impressive.  
        Look into src/cnt for content (.cnt) example files or src/json for example  
        JSON files.  
  
    src/config/  
        The src/config directory contains an example presentation config. run.py is able to load these configs  
        and won't ask you for furhter presentation information.  
            # ./run.py json config/example.json  
  
    src/json & src/cnt  
        Example JSON and .cnt files  
  
  
.cnt  
    You can use the nl2br markdown for your slide or step content files. This will be parsed on the  
    fly into the index.html file, the .cnt files themselves will not be overwritten.  
  
.json  
    The .json files contain your step configurations.  
  
ATTENTION: Please read the README.md file in the projects main folder. The README file also contains naming  
conventions in impressive.  
  

Function Documentation:  
  
impressive.py  
  
#updateContent(jsonObj)  
    This functions allows you to update the .json files with the content from their respective .cnt files.  
    If you execute this funtion for the first time your JSON object will be extended by a "content-sum"  
    and a "content-parsed" key/value pair.  
    "content-sum"       ::  SHA256 Sum of the file content, we need it for checking fast on updates  
    "content-parsed"    ::  The value which is stored inside this is the parsed content (by parseMarkup())  
    The updateContent function will return a tuple with the a boolean value (indicating if everything went  
    fine or not) and the manipulated JSON object. It also writes the JSON object in its file.  
  
#idMaker(jsonDirectoryPath)  
    The jsonDirectoryPath is the path to your presentation JSON folder (if you won't change the setup it should  
    be exec/json).  
  
    The idMaker looks into your JSON folder and generates the id's for the HTML generator.  
  
#parseMarkup(content)  
    content :: The content for one step  
  
    You can use the nl2br markdown language to easily edit your steps. I decided to use it, because I wanted  
    an impress.js generator which doesn't need any HTML knowledge and I think, that nl2br is easier to learn than  
    HTML.  
    This function returns the respective HTML output (utf-8) of your content.  
  
#containerGenerator(jsonDirectoryPath)  
    The jsonDirectoryPath is the path to your presentation JSON folder (if you won't change the setup it should  
    be exec/json).  
  
    This function generates the HTML step div-tags filled up with your content as a list.  

#generateHTML( ... )  
    generateHTML(divSlides_filled,  
        language="de",  
        charset="utf-8",  
        viewport_width=1024,  
        title="",  
        description="No description",  
        author="John Doe", 
        stylesheet="css/style.css")  


    Okay this functions put's everything together. You pass the div-tag list (divSlides_filled) and a few presentation  
    specific parameters like language, title, author, etc. I think you are able to read a function declaration.  
    The standard values for charset and viewport are not accessable via the generator or a config, you have to  
    change this hardly in the impressive code.  
  
    This function will write an index.html file to presentation/index.html, so your old index.html will be  
    overwritten without asking! When everything went fine this function will return True  
